(define (c1future forms)        ;;; T.Komiya
  (and (pair? forms)
       (not (null? (cdr forms)))
       (scerror "~s is a bad arg to FUTURE." forms))
  (let ((form (car forms)))
    (cond ((symbol? form)
           (scerror "not implemented yet(future)."))
          ((pair? form)
           (let ((fun (car form)) (args (cdr form)))
             (cond ((symbol? fun)
                    (case fun
                      ((if cond case and or begin lambda delay
                        make-placeholder future xspawn-thread spawn-thread
                        let let* letrec do set! quote quasiauote define macro)
                       (scerror "not implemented yet(future)."))
                      (else (and (>= *re-compile-level* 2)
                                 (set-fun-data fun))
                            (if (macro-function fun)
                                (c1future ((macro-function fun) form))
                                (c1symbol-fun-lt fun args)))))
                   ((and (pair? fun) (eq? (car fun) 'lambda))
                    (scerror "not implemented yet(future)."))
                   (else
                     (scerror "not implemented yet(future).")))))
          (else
            (scerror "not implemented yet(future).")))))

(define (c1symbol-fun-lt name args)  ;;; T.Komiya
  (let parse ((env *env*) (ccb #f))
    (cond ((null? env) `(,c2funcall-lt (,c2gvref ,name) ,(c1args args)))
          ((eq? (car env) 'CB) (parse (cdr env) #t))
          ((eq? (var-name (car env)) name)
           (if ccb (set-var-closed (car env) #t))
           `(,c2funcall-lt (,c2vref ,(car env) ,ccb) ,(c1args args)))
          (else (parse (cdr env) ccb)))))

(define (c2funcall-lt fun args)     ;;; T.Komiya
  (if (and (eq? (car fun) c2vref) (var-local-fun (cadr fun)))
      (if (let* ((actuals (length args))
                 (x (var-local-fun-args (cadr fun)))
                 (requireds (length (car x))))
            (or (< actuals requireds)
                (and (null? (cadr x)) (> actuals requireds))))
          (scerror "Wrong number of args to the local fun ~s."
                   (var-name (cadr fun)))
          (cond ((and (not (eq? *value-to-go* 'PUSH))
                      (or (eq? *exit* 'NEXT) (eq? *exit* 'ESCAPE)))
                 (c2lcall-lt (touch-label *exit-label*) fun args))
                (else (let ((label (next-label2)))
                        (c2lcall-lt (touch-label label) fun args)
                        (wt-label label))
                      (if (eq? *value-to-go* 'PUSH) (wt '(push-bx)))
                      (exit))))

      (or (c2call-touch-function fun args)
          (and *inline-functions* (c2call-simple-function fun args))
          (cond ((and (not (eq? *value-to-go* 'PUSH))
                      (or (eq? *exit* 'NEXT) (eq? *exit* 'ESCAPE)))
                 (c2xcall-lt *exit-label* fun args))
                (else (let ((label (next-label2)))
                        (c2xcall-lt label fun args)
                        (wt-label label))
                      (if (eq? *value-to-go* 'PUSH) (wt '(push-bx)))
                      (exit))))))

(define (c2lcall-lt return fun args)   ;;; T.Komiya
  (dlet ((*bp* *bp*) (*sp* *sp*))
    (let ((level (- *level* (var-local-fun (cadr fun)))))
      (if (negative? level)
          (wt `(open-lltframe-1 ,*bp* ,return))
          (wt `(open-lltframe ,*bp* ,level ,return))))
    (for-each c2push-expr* args)
    (wt `(lcall ,(touch-label (var-loc (cadr fun)))))))

(define (c2xcall-lt return fun args)   ;;; T.Komiya
  (dlet ((*bp* *bp*) (*sp* *sp*))
    (wt `(open-ltframe ,(touch-label return)))
    (c2push-expr* fun)
    (let ((old-sp *sp*))
      (for-each c2push-expr* args)
      (if (car (touch-arg-info fun)) (wt `(touch ,(- old-sp *bp*))))
      (wt '(xcall)))))

(define (wt code)
  (set-cdr! *bc-codep* (list code))
  (set! *bc-codep* (cdr *bc-codep*))
  (if (pair? code)
      (case (car code)
        ((open-frame open-ltframe)
         (set! *sp* (- *sp* *open-frame-pushes*))
         (set! *bp* *sp*))
        ((open-lframe open-lframe-1 open-lltframe open-lltframe-1)
         (set! *sp* (- *sp* *open-lframe-pushes*))
         (set! *bp* *sp*))
        ((make-cons eq? eqv? equal? + * - / < > <= >= =
          set-car! set-cdr! vector-ref)
         (set! *sp* (+ *sp* 1)))
        ((vector-set!) (set! *sp* (+ *sp* 2))))))
