#|
(define (get-name exp)       
  (case (car exp)
    ((define macro)
     (if (symbol? (cadr exp))
         (if (pair? (caddr exp))
             (case (caaddr exp)
               ((lambda let) (cadr exp))
               (else #f)) #f)
         (caadr exp)))
    (else #f)))
|#

;; T.Komiya
(define (get-name exp)
  (case (car exp)
    ((define macro)
     (if (symbol? (cadr exp))
         (and (pair? (caddr exp)) (eq? (caaddr exp) 'lambda) (cadr exp))
         (caadr exp)))
    (else #f)))

(define (compile-system exp fun-name check-com)
  (if fun-name
      (let ((clos (get-symbol-value fun-name)))
        (if (or (null? (get-fun-name clos)) (not (get-fun-name clos)))
            (put-fun-name clos (symbol->string fun-name)))
        (if (or (null? (get-source clos)) (not (get-source clos)))
            (put-source clos (caddr exp)))
        (if (>= *re-compile-level* 2)
            (begin
              (if (not (null? *fun-data*)) (putpropfun clos *fun-data*))
              (if (or check-com (macro-function fun-name))
                  (begin ;(display '>>>>>) (display fun-name) (newline)
                    (re-compile (seek-plist fun-name clos))))))))) ; T.Komiya
;                   (re-compile (seek-plist fun-name clos '())))))))))

(define (putpropfun clos fun-data)      ;;;;;
  (for-each
    (lambda (name1)
     (let ((answer #f))
       (if (getprop name1 'redef)
           (begin (do ((name2 (getprop name1 'redef) (weak-cdr name2)))
                      ((null? name2))
                    (set! answer (or answer (eq? clos (weak-car name2)))))
                  (if (not answer)
                      (putprop name1 'redef
                               (weak-cons clos (getprop name1 'redef)))))
           (putprop name1 'redef (weak-cons clos '())))))
    fun-data))

#|
(define (seek-plist def-name def-clos compile-data)   ;;;;; 
  (if (not (getprop def-name 'redef))
      compile-data
      (do ((fun (getprop def-name 'redef) (weak-cdr fun))
           (def-names '()))
          ((null? fun)
           (for-each
             (lambda (x)
               (set! compile-data (seek-plist x def-clos compile-data)))
             def-names)
           compile-data)
        (let* ((clos (weak-car fun))
               (check-1 (check-plist clos compile-data))
               (check-2 (not (eq? clos def-clos))))
          (if (and clos check-1 check-2)
              (set! compile-data (cons clos compile-data)))
          (if (check-mac clos)
              (if (and check-1 check-2)
                  (set! def-names (cons (string->symbol (get-fun-name clos))
                                        def-names))
                  (begin
                    (newline) 
                    (display '=warnning-macro-recursive=) (newline))))))))
|#

;; T.Komiya
(define (for-each-for-wp fun arg-list)
  (if (null? arg-list)
      '()
      (begin
        (apply fun (list (weak-car arg-list)))
        (for-each-for-wp fun (weak-cdr arg-list)))))

;; T.Komiya
(define (seek-plist def-name def-clos)
  (define (make-adjmat def-name def-clos)
    (let ((adjacent '())
          (nodes '()))
      (define (aux name closure)
        (if (not (assq closure adjacent))
            (begin
              (set! nodes (cons (cons closure 'never) nodes))
              (set! adjacent
                    (cons (cons closure
                                (or (and (check-mac closure)
                                         (getprop name 'redef))
                                    '()))
                          adjacent))
              (if (check-mac closure)
                  (for-each-for-wp
                    (lambda (x)
                      (and x (aux (string->symbol (get-fun-name x)) x)))
                    (cdar adjacent))))))
      (aux def-name def-clos)
      (cons adjacent nodes)))
  (define (topological-sort adj data)
    (let ((sorted-data '()))
      (define (visit node)
        (set-cdr! node 'just)
        (for-each-for-wp
          (lambda (x)
            (let ((n (assq x data)))
              (and n (case (cdr n)
                       ((never) (visit n))
                       ((just) (format #t
                                 "Warning: macro call is recursive.~%"))))))
          (cdr (assq (car node) adj)))
        (set-cdr! node 'once)
        (set! sorted-data (cons (car node) sorted-data)))
      (for-each
        (lambda (x)
          (if (eq? (cdr x) 'never) (visit x)))
        data)
      sorted-data))
  (let ((x (make-adjmat def-name def-clos)))
    (cdr (topological-sort (car x) (cdr x)))))
        
(define (check-plist clos compile-data)    
  (let ((answer #f))
    (for-each
      (lambda (data)
        (set! answer (or answer (eq? clos data)))) compile-data)
    (not answer)))

(define (re-compile data)                
  (erace-compilefun data *fun-data*)
  (set! *fun-data* '())
  (for-each
    (lambda (clos)
      (let ((new-clos (bctran-exec-form (compile (get-source clos))
                                        (get-source clos))))
        (display clos) (display " is re-compiled.") (newline)
        (change-bci clos new-clos)
        (erace-lostobject clos)
        (putpropfun clos *fun-data*)
        (set! *fun-data* '())))
    data))    ;; T.Komiya
;    (sort-data data)))

#|
(define (sort-data data)   
  (let ((new-data '()))
    (for-each (lambda (clos)
        (if (not (check-mac clos)) 
          (set! new-data (cons clos new-data)))) data)
    (for-each (lambda (clos)
        (if (check-mac clos)
          (set! new-data (cons clos new-data)))) data)
    new-data))
|#

(define (erace-lostobject name)        ;;;;;
  (let* ((name (if (symbol? name) name (string->symbol (get-fun-name name))))
         (old-data (getprop name 'redef))
         (new-data '()))
    (putprop name 'redef '())
    (if old-data
        (do ((data old-data (weak-cdr data)))
            ((null? data) (putprop name 'redef new-data))
          (if (weak-pair/car? data)
              (set! new-data (weak-cons (weak-car data) new-data)))))))

(define (erace-compilefun data fun-data)    ;;;;;
   (for-each
     (lambda (data1) 
       (for-each
         (lambda (name)
           (let ((old-data (getprop name 'redef))
                 (new-data '()))
             (putprop name 'redef '())
             (if old-data
                 (do ((data2 old-data (weak-cdr data2)))
                     ((null? data2) (putprop name 'redef new-data))
                   (if (not (eq? data1 (weak-car data2)))
                       (set! new-data (weak-cons (weak-car data2)
                                                 new-data)))))))
         fun-data))
     data))

(define (recom clos)    
  (let ((name (string->symbol (get-fun-name clos))))
    (set! *fun-data* '())
    (compile (get-source clos))
    (putpropfun name *fun-data*)
    (set! *fun-data* '())))

(define (set-fun-data fun)
  (let ((answer #f))
    (for-each
      (lambda (name)
        (set! answer (or answer (eq? fun name))))
      *fun-data*)
    (if (not answer) (set! *fun-data* (cons fun *fun-data*)))))

(define (automatic-recompilation?) (= *re-compile-level* 2))

(define (clear-redef x)
  (for-each (lambda(fun)
              (putprop fun 'redef #f)) x)
  (for-each (lambda(fun)
              (clear-source (eval fun))) x))
