(set! *re-compile-level* 2)

;(define ($$display . x)
;  (update)
;  (apply display x)
;  (flush-port *stdout*))

;;;

(define (tk:update) (exectcl "update"))

(define (tk:loop) (exectcl "do_one_event") (tk:loop))

(define (->scmobj x) (read (open-input-string x)))

(define (tk:apply f . x) (apply (get-symbol-value (->scmobj f))
                                (map ->scmobj x)))

(define (tk:getvar x) (->scmobj (exectcl (format #f "set ~a" x))))

(define (tk:setvar x y) (exectcl (format #f "set ~a {~a}" x y)))

(define :anchor '-anchor)
(define :arrow '-arrow)
(define :background '-background)
(define :bd '-bd)
(define :bg '-bg)
(define :borderwidth '-borderwidth)
(define :command '-command)
(define :expand '-expand)
(define :fill '-fill)
(define :file '-file)
(define :fg '-fg)
(define :font '-font)
(define :from '-from)
(define :height '-height)
(define :ipadx '-ipadx)
(define :image '-image)
(define :ipady '-ipady)
(define :label '-label)
(define :menu '-menu)
(define :orient '-orient)
(define :outline '-outline)
(define :padx '-padx)
(define :pady '-pady)
(define :relief '-relief)
(define :raised '-raised)
(define :scrollregion '-scrollregion)
(define :side '-side)
(define :smooth '-smooth)
(define :splinesteps '-splinesteps)
(define :stipple '-stipple)
(define :tags '-tags)
(define :text '-text)
(define :textvariable '-textvariable)
(define :to '-to)
(define :underline '-underline)
(define :width '-width)
(define :window '-window)
(define :wrap '-wrap)
(define :xscroll '-xscroll)
(define :xscrollcommand '-xscrollcommand)
(define :yscroll '-yscroll)
(define :yscrollcommand '-yscrollcommand)

(define genfname
  (let ((n 0))
    (lambda ()
      (set! n (1+ n))
      (string->symbol (format #f "__tk__~a" n)))))

(define (scmlist->tcllist l)
  (let ((p (open-output-string)))
    (dolist (x l)
      (cond ((boolean? x)
             (write (if x 1 0) p))
            ((function? x)
             (let ((n (genfname)))
               (eval `(define ,n ,x))
               (format p "{apply_sfun tk:apply ~a}" n)))
            ((and (rational? x) (not (integer? x)))
             (write (_exact->inexact x) p))
            (else
              ((if (symbol? x) display write) x p)))
      (display #\space p))
    (get-output-string p)))

(define (scmlist->tcllist2 l)
  (let ((p (open-output-string)))
    (dolist (x l)
      (cond ((boolean? x)
             (write (if x 1 0) p))
            ((function? x)
             (display (get-procedure-name x) p))
            ((and (rational? x) (not (integer? x)))
             (write (_exact->inexact x) p))
            (else
              ((if (symbol? x) display write) x p)))
      (display #\space p))
    (get-output-string p)))

(define (scmlist->tcllist3 l)
  (let ((p (open-output-string)))
    (dolist (x l)
      (cond ((boolean? x)
             (write (if x 1 0) p))
            ((function? x)
             (let ((n (genfname)))
               (eval `(define ,n ,x))
               (format p "{apply_sfun tk:apply ~a" n)
               (dolist (a (cadr (get-source x)))
                 (format p " ~a" a))
               (format p "}")))
            ((and (rational? x) (not (integer? x)))
             (write (_exact->inexact x) p))
            (else
              ((if (symbol? x) display write) x p)))
      (display #\space p))
    (get-output-string p)))

(define (create-tkobj com path opt)
  (let ((path (if (function? path)
                  (string->symbol (get-procedure-name path))
                  path)))
    (eval `(define (,path . opt)
             (let* ((x (exectcl (scmlist->tcllist (list* ',path opt))))
                    (n (tcllist->scmlist x)))
               (if (null? (cdr n)) (car n) x))))
    (let* ((x (exectcl (scmlist->tcllist (list* com path opt))))
           (n (tcllist->scmlist x)))
      (if (null? (cdr n)) (car n) x))))

(define (create-tkobj2 com path opt)
  (let ((path (if (function? path)
                  (string->symbol (get-procedure-name path))
                  path)))
    (eval `(define (,path . opt)
             (let* ((x (exectcl (scmlist->tcllist (list* ',path opt))))
                    (n (tcllist->scmlist x)))
               (if (null? (cdr n)) (car n) x))))
    (let* ((x (exectcl (scmlist->tcllist3 (list* com path opt))))
           (n (tcllist->scmlist x)))
      (if (null? (cdr n)) (car n) x))))

(define (create-tkobj3 com path opt)
  (let ((path (if (function? path)
                  (string->symbol (get-procedure-name path))
                  path)))
    (eval `(define (,path . opt)
             (let* ((x (exectcl (scmlist->tcllist3 (list* ',path opt))))
                    (n (tcllist->scmlist x)))
               (if (null? (cdr n)) (car n) x))))
    (let* ((x (exectcl (scmlist->tcllist (list* com path opt))))
           (n (tcllist->scmlist x)))
      (if (null? (cdr n)) (car n) x))))

(define (tcllist->scmlist s)
  (let ((p (open-input-string s)))
    (let loop ((l '()) (x (read p)))
      (if (eof-object? x)
          (nreverse l)
          (loop (cons x l) (read p))))))

(define (entry path . opt) (create-tkobj 'entry path opt))
(define (canvas path . opt) (create-tkobj3 'canvas path opt))
(define (label path . opt) (create-tkobj 'label path opt))
(define (pack . opt) (exectcl (scmlist->tcllist2 (list* 'pack opt))))
(define (destroy . opt) (exectcl (scmlist->tcllist2 (list* 'destroy opt))))
(define (button path . opt) (create-tkobj 'button path opt))
(define (radiobutton path . opt) (create-tkobj 'radiobutton path opt))
(define (checkbutton path . opt) (create-tkobj 'checkbutton path opt))
(define (menubutton path . opt) (create-tkobj 'menubutton path opt))
(define (text path . opt) (create-tkobj 'text path opt))
(define (toplevel path . opt) (create-tkobj 'toplevel path opt))
(define (scrollbar path . opt) (create-tkobj 'scrollbar path opt))
(define (listbox path . opt) (create-tkobj 'listbox path opt))
(define (frame path . opt) (create-tkobj 'frame path opt))
(define (scale path . opt) (create-tkobj 'scale path opt))
(define (menu path . opt) (create-tkobj 'menu path opt))
(define (wm com . opt) (create-tkobj 'wm com opt))
(define (bind path . opt) (create-tkobj2 'bind path opt))
(define (winfo . opt) (exectcl (scmlist->tcllist2 (list* 'winfo opt))))
(define (focus . opt) (exectcl (scmlist->tcllist2 (list* 'focus opt))))
(define (image . opt) (exectcl (scmlist->tcllist2 (list* 'image opt))))

(define (glob . opt)
  (let ((i 0))
    (define (gettk str)
      (let loop ()
        (and (< i (string-length str))
             (char=? (string-ref str i) #\space)
             (begin (set! i (1+ i)) (loop))))
      (let loop ((ss '()))
        (if (or (>= i (string-length str))
                (char=? (string-ref str i) #\space))
            (list->string (nreverse ss))
            (begin
              (set! i (1+ i))
              (loop (cons (string-ref str (1- i)) ss))))))
    (let ((str (exectcl (scmlist->tcllist2 (list* 'glob opt)))))
      (let loop ((l '()) (x (gettk str)))
        (if (equal? "" x)
            l
            (loop (cons x l) (gettk str)))))))

#|
;;; Example 1

(define (power)
  (define (aux base p result)
    (if (not (> p 0))
        (tk:setvar 'result result)
        (aux base (1- p) (* result base))))
  (aux (tk:getvar 'base) (tk:getvar 'power) 1))

(entry '.base :width 6 :relief 'sunken :textvariable 'base)
(label '.label1 :text "to the power")
(entry '.power :width 6 :relief 'sunken :textvariable 'power)
(label '.label2 :text "is")
(label '.result :textvariable 'result)
(pack .base .label1 .power .label2 .result :side 'left :padx '1m :pady '2m)
(bind '.base "<Return>" power)
(bind '.power "<Return>" power)

;;; Example 2

(define (power)
  (define (aux base p result)
    (if (not (> p 0))
        (.result 'configure :text result)
        (aux base (1- p) (* result base))))
  (aux (.base 'get) (.power 'get) 1))

(entry '.base :width 6 :relief 'sunken)
(label '.label1 :text "to the power")
(entry '.power :width 6 :relief 'sunken)
(label '.label2 :text "is")
(label '.result)
(pack .base .label1 .power .label2 .result :side 'left :padx '1m :pady '2m)
(bind '.base "<Return>" power)
(bind '.power "<Return>" power)
|#
