(define compile '())
(define compile-function '())
(define set-handler-stack! '())  ;;; By N.Watanabe
(define compile-system '())      ;;;;; By A243  Nov, 1992 ;;;;;
(define get-name '())

(define *fun-data* '())        ;;;;; By A243  Nov, 1992 ;;;;;

(define *_init_scheme* #f)
(define *_init_common* #t)

(define sctop
  (let ((byebye bye))
    (lambda ()
      (define (substring? sub str)
        (do ((i (- (string-length str) (string-length sub)) i)
             (l (string-length sub) l)
             (j 0 (1+ j))
             (ret #f ret))
            ((> j i) ret)
          (if (string=? sub (substring str j (+ j l)))
              (begin
                (set! ret #t)
                (set! j (1+ i))))))
      (let ((input nil))
        (if *_init_common*
            (let ((with-L-opt? (let loop ((av (cdr *argv*)))
                                 (cond ((null? av) #f)
                                       ((substring? "-L" (car av)) #t)
                                       (else (loop (cdr av)))))))
              (dlet ((*loading-message* (not with-L-opt?)))
                (load (string-append *faslib-path* "/common.fas"))
                (load (string-append *faslib-path* "/process.lsp"))
                (load (string-append *faslib-path* "/help.fas"))
                (load (string-append *faslib-path* "/err_system.fas"))
                (if (bound? 'exectcl)   ; for TUS/Tk
                    (load (string-append *faslib-path* "/tk.lsp"))))
              (set! *_init_common* #f)
              (set! *_init_scheme* #t)
              (if with-L-opt? (sctop)))
            (if *_init_scheme*
                (begin
                  (if (or (file-exists? "scheme.lsp")
                          (file-exists? "scheme.fas"))
                      (load 'scheme)
                      (let* ((scm-dir (getenv "SCM_DIR"))
                             (path "scheme")
                             (exist-file '()))
                        (if (not (zero? (string-length scm-dir)))
                            (begin
                              (set! path (string-append scm-dir "/" path))
                              (set! exist-file
                                    (or (and (file-exists?
                                               (string-append path ".fas"))
                                             ".fas")
                                        (and (file-exists?
                                               (string-append path ".lsp"))
                                             ".lsp")))
                              (if exist-file
                                  (load (string-append path exist-file)))))))
                  (set! *_init_scheme* #f))))
        (set-handler-stack! '())      ;;; By N.Watanabe 
        (set! *debugger-level* 0)     ;;;   for error handler and
        (set! *dbg-cont-stack* '())   ;;;       debugger.
        (set! *condition-stack* '())  ;;;
        (do () (#f)
          (set! *trace-level* 0)
          (display #\newline)
          (display "SC> ")
          (flush-port *stdout*)
          (set! input (read))
          (if (not (eof-object? input))
              (write (eval input))
              (begin (display #\newline)
                     (byebye))))))))

;; SCTOP for -e option --- read-eval loop
(define (eosctop . strport)
  (let ((strport (if (null? strport)
                     (console-input-port)
                     (car strport)))
        (input nil))
    (set! *loading-message* #f)
    (if (or (file-exists? "scheme.lsp") (file-exists? "scheme.fas"))
        (load 'scheme)
        (let* ((scm-dir (getenv "SCM_DIR"))
               (path "scheme")
               (exist-file '()))
          (if (not (zero? (string-length scm-dir)))
              (begin
                (set! path (string-append scm-dir "/" path))
                (set! exist-file
                      (or (and (file-exists? (string-append path ".fas"))
                               ".fas")
                          (and (file-exists? (string-append path ".lsp"))
                               ".lsp")))
                (if exist-file
                  (load (string-append path exist-file)))))))
    (set-handler-stack! '())      ;;; By N.Watanabe 
    (set! *debugger-level* 0)     ;;;   for error handler and
    (set! *dbg-cont-stack* '())   ;;;       debugger.
    (set! *condition-stack* '())  ;;;
    (do () (#f)
      (set! *trace-level* 0)
      (set! input (read strport))
      (if (not (eof-object? input))
          (eval input)
          (eval '(exit-tus))))))

(define (eval exp)                   ;;;;; By A243  Dec,1992 ;;;;;
  (set! *fun-data* '())              
  (cond ((symbol? exp)
	     (get-symbol-value exp))
        ((pair? exp)
         (if (>= *re-compile-level* 1)
           (let* ((lambda-source (get-lambda-source exp)) 
                  (fun-name (get-name exp))
                  (check-com (if fun-name (macro-function fun-name) #f))
                  (result (bctran-exec-form (compile exp) lambda-source)))
             (compile-system exp fun-name check-com) 
             (eval-answer exp result))
           (let ((result (bctran-exec-form (compile exp) '())))
             (eval-answer exp result))))
        (else exp)))

(define (get-lambda-source exp)   
  (case (car exp)
          ((define macro)
             (if (symbol? (cadr exp)) (caddr exp)
               (cons 'lambda (cons (cdadr exp) (cddr exp)))))
          (else '())))

(define (eval-answer exp result)
  (case (car exp)
    ((define macro)
     (if (pair? (cadr exp))
       (caadr exp)
       (cadr exp)))
    (else result)))


(define (define-a-function first args body)
  (bctran-define-form (compile-function first args body))
  (car args))


;(define (exec-exp exp)
;  (let* ((bc (compile-function 'define '(top-level) (list exp)))
;	 (first (car bc))
;	 (body (caddr bc))
;	 (func (apply bctran-bcbody
;	              first
;		      (cadr (cadr body))	;;; name
;		      (caddr body)		;;; arg-info
;		      (cadr (cadddr body))	;;; byte code list
;		      () )))
;   (user-function-apply func ())))


(define (top-level-error . message)
  (print2 "top-level-error: ")
  (apply print2 message)
  (error-break))


(define aaa (protect-symbol 'xreturn))
(define aaa (protect-symbol 'lreturn))
(define aaa (protect-symbol 'xcall))
(define aaa (protect-symbol 'make-nil-closure))
